package classifier;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.Packet;
import weka.clusterers.EM;
import weka.core.Instance;
import weka.core.Instances;

/**
 * Expectation Maximization Clustering Approach
 * @author Andreas T. Meyer-Berg
 */
public class EMClustering extends BasicPacketClassifier {

	/**
	 * EM cluster which is used
	 */
	private EM clusterer;
	
	/**
	 * Initialize the clusterer
	 */
	public EMClustering() {
		clusterer = new EM();
	}
	
	@Override
	public void trainModel(Instances instances) {
		try {
			clusterer.buildClusterer(instances);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	@Override
	public void classifyInstance(Instance instance, Packet origin) throws Exception {
		clusterer.clusterInstance(instance);
	}

	@Override
	public long getClassificationStart() {
		return 3600000;
	}

	@Override
	public String getAlgoName() {
		return "EM";
	}

}
